Subject: bug#9897: 24.0.90; w32 control character configuration is severely lacking compared to ns-win.el

From: Tim Visher <[email-masked]>
Date: Fri, 28 Oct 2011 15:43:17 -0400

On Fri, Oct 28, 2011 at 2:47 PM, Eli Zaretskii <[email-masked]> wrote:
>> From: Tim Visher <[email-masked]>
>> Date: Fri, 28 Oct 2011 11:14:06 -0400
>>
>> I'm trying to configure what pressing Alt, Windows, Apps, and Control on
>> a windows keyboard translates to in emacs. I use emacs on both Macs and
>> Windows boxen and I'm used to configuring the keys on macs using
>> ns-win.el bindings like:
>>
>>     (if (boundp 'mac-command-modifier) (setq mac-command-modifier 'control))
>>     (if (boundp 'mac-option-modifier) (setq mac-option-modifier 'meta))
>>     (if (boundp 'mac-control-modifier) (setq mac-control-modifier 'super))
>>
>> Compared to that library, the ability to configure what the meta keys
>> map to on windows is severely lacking, not allowing configuration at all
>> of what the control-modifier is mapped to, and providing only toggles
>> for the windows keys and apps keys.
>
> What other keys do you have on your keyboard that you'd like to
> configure on Windows?  There's no "command modifier" and no "option
> modifier" on Windows.
>
> Note that in addition to what you mentioned, there's
> w32-enable-caps-lock and w32-enable-num-lock that you can use to
> produce 2 more symbols.
>

Thanks for your quick response!

I'm essentially looking for modifier key parity with ns ala:

http://bzr.savannah.gnu.org/lh/emacs/trunk/annotate/head:/lisp/term/ns-win.el#L182

On Windows, that list would probably look like:

    (defvaralias 'pc-allow-anti-aliasing 'pc-antialias-text)
    (defvaralias 'pc-windows-modifier 'pc-windows-modifier)
    (defvaralias 'pc-right-windows-modifier 'pc-right-windows-modifier)
    (defvaralias 'pc-control-modifier 'pc-control-modifier)
    (defvaralias 'pc-right-control-modifier 'pc-right-control-modifier)
    (defvaralias 'pc-alt-modifier 'pc-alt-modifier)
    (defvaralias 'pc-right-alt-modifier 'pc-right-alt-modifier)
    (defvaralias 'pc-function-modifier 'pc-function-modifier)
    (defvaralias 'pc-apps-modifier 'pc-apps-modifier)

And then you could set them using the same contract that I listed in
the opening mail.

Make sense?